/*
 * TestBeanFrameComponents.java
 *
 *
 */
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import sferyx.administration.editors.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import sferyx.javascript.engine.*;
/**
 *
 * @author  Vassil Boyadjiev
 */
public class ReferencingDocumentElements extends JFrame implements MouseListener {

    /** Creates new form ReferencingDocumentElements */
    public ReferencingDocumentElements() {
        initComponents();
        
        JScrollPane scroll=new JScrollPane(textConsole);
        scroll.setPreferredSize(new Dimension(200,400));
        getContentPane().add(scroll,"East");
        
        hTMLEditor1.setContent("<form id=\"11\"><input type=\"submit\" name=\"my_button\" id=\"3246\"></form>");
        jsEngine=new JavaScriptEmulatorEngine(hTMLEditor1);
    }
    
    JTextArea textConsole=new JTextArea();

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        hTMLEditor1 = new sferyx.administration.editors.HTMLEditor();
        buttonsPanel = new javax.swing.JPanel();
        printFormElements = new javax.swing.JButton();
        getByIDButton = new javax.swing.JButton();
        getByTagButton = new javax.swing.JButton();
        addMouseListenerButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        hTMLEditor1.setRemovedMenuItems("");
        hTMLEditor1.setStatusMessage("");
        hTMLEditor1.setTableItemsStatus(false);
        getContentPane().add(hTMLEditor1, java.awt.BorderLayout.CENTER);

        printFormElements.setText("Print Form Elements");
        printFormElements.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                printFormElementsActionPerformed(evt);
            }
        });

        buttonsPanel.add(printFormElements);

        getByIDButton.setText("Get Elements by ID");
        getByIDButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getByIDButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(getByIDButton);

        getByTagButton.setText("Get Elements by Tag");
        getByTagButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getByTagButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(getByTagButton);

        addMouseListenerButton.setText("Add Mouse Listener");
        addMouseListenerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMouseListenerButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(addMouseListenerButton);

        getContentPane().add(buttonsPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void addMouseListenerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addMouseListenerButtonActionPerformed
        // Add your handling code here:
        attachMouseListenerToComponent();
    }//GEN-LAST:event_addMouseListenerButtonActionPerformed

    private void getByTagButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getByTagButtonActionPerformed
        // Add your handling code here:
        printElementsByTag();
    }//GEN-LAST:event_getByTagButtonActionPerformed

    private void getByIDButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getByIDButtonActionPerformed
        // Add your handling code here:
        printElementsByID();
    }//GEN-LAST:event_getByIDButtonActionPerformed

    private void printFormElementsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printFormElementsActionPerformed
        // Add your handling code here:
        printFormElements();
    }//GEN-LAST:event_printFormElementsActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        
           try
      {
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      }
      catch(Exception exc)
      {
      }  
        
       ReferencingDocumentElements frame=new ReferencingDocumentElements();
       frame.setLocation(200,200);
       frame.setSize(800,600);
       frame.show();
    }

    public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
    }

    public void mouseReleased(java.awt.event.MouseEvent mouseEvent)
    {

        textConsole.append("==> Mouse Released:"+mouseEvent+"\n");

       
    }

    
    public void printFormElements()
    {
        
         
       // Note that if there are no forms, the "forms" property will be null. Handle this accordingly
        // In these case use the alternative ways are to use the getElementById, getElementsByTagName or getElementsByName
        if(jsEngine.getDocument().forms==null)
        {
            
            textConsole.append("No form elements in the document\n");
            return;
            
        }
         
        DocumentElement[] elements=jsEngine.getDocument().forms[0].elements;
     
     
        for(int i=0;i<elements.length;i++)
        {
            textConsole.append("------Element Start---------\n");
            textConsole.append(elements[i]+"\n");
            textConsole.append("------Element End---------\n");
        }
        
        
    }
    
    public void printElementsByID()
    {
        
        
        //Will return the element with specified ID attribute
        
            DocumentElement element=jsEngine.getDocument().getElementById("3246");
         
        
            textConsole.append("------Element Start---------\n");
            textConsole.append(element+"\n");
            textConsole.append("------Element End---------\n");
        
        
        
    }

    
    public void printElementsByTag()
    {
        
        //Will return all elements with specified tag
        
        
        DocumentElement[] elements=jsEngine.getDocument().getElementsByTagName("INPUT");
       //   DocumentElement[] elements=jsEngine.getDocument().getElementsByTagName("IMG");
         
        for(int i=0;i<elements.length;i++)
        {
            textConsole.append("------Element Start---------\n");
            textConsole.append(elements[i]+"\n");
            textConsole.append("------Element End---------\n");
        }
        
        
    }
    
    
    
    public void attachMouseListenerToComponent()
    {
     
        //Will attach a mouse listener to an element with specified ID attribute.
        
              DocumentElement element=jsEngine.getDocument().getElementById("3246");                   
              JComponent component=SferyxUtilities.getJavaFormItemComponent(element, hTMLEditor1);
              textConsole.append("Adding Mouse Listener to :"+component+"\n");
              component.addMouseListener(this);
        
    }
    
    

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton getByIDButton;
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JButton addMouseListenerButton;
    private sferyx.administration.editors.HTMLEditor hTMLEditor1;
    private javax.swing.JButton getByTagButton;
    private javax.swing.JButton printFormElements;
    // End of variables declaration//GEN-END:variables

    

    JavaScriptEmulatorEngine jsEngine;
    
}


